macroScript Corona_tweaks category:"Corona Renderer" 
buttontext:"Corona Tools"  toolTip:"Corona Renderer tweaker"
(
try (cui.UnRegisterDialogBar Corona_tweaker) catch()
try (cui.FloatDialogBar Corona_tweaker) catch()
try (destroydialog Corona_tweaker) catch()
--try (renderers.current.denoise_filterType = 0) catch()	
	
Rollout Corona_tweaker "CoronaRndTweaker"	
(
/*
.vfb_clearBetweenRenders (framebuffer_clearVfbInbetweenRenders) : boolean
.mtlEditor_quality (system_materialEditorPreviewQuality) : float

	*/

GroupBox grp1 "Materials Settings:" pos:[3,0] width:116 height:164
	
	/*spinner dll "LimitDiff:"  pos:(grp1.pos+[19,20]) width:65 height:16 range:[0.00,1,1] type:#float 
		tooltip:"Set global upper limit of diffuse level of all scene materials"
	button dllb "push"  pos:(grp1.pos+[87,18]) width:29 height:20 	
		on dllb pressed do
			for i in getclassinstances coronamtl do
			( if i.leveldiffuse > dll.value then i.leveldiffuse = dll.value )	
	*/		
	spinner tbs "BitmapsBlur"  pos:(grp1.pos+[12,15]) width:85 height:16 range:[0.01,1,0.01] type:#float
		tooltip:"Set global blur for all bitmaps in scene"
	button tbsb "Do"  pos:(grp1.pos+[99,16]) width:15 height:14 

	on tbsb pressed do
	(
	for mp in getClassInstances Bitmaptexture do 
			( 	mp.coords.blur = tbs.value )
	for mpc in getClassInstances CoronaBitmap do 
			( 	mpc.filteringBlur = tbs.value  )
	)
		
	spinner dll "LimitDiff:"  pos:(grp1.pos+[33,34]) width:64 height:16 range:[0.00,1,1] type:#float 
		tooltip:"Set global upper limit of diffuse level of all scene materials"
	
	button dllb "Do"  pos:(grp1.pos+[99,35]) width:15 height:14 	
		on dllb pressed do
			for i in getclassinstances coronamtl do
			( if i.leveldiffuse > dll.value then i.leveldiffuse = dll.value)
			
	button dll1 "=1"  pos:(grp1.pos+[2,34]) width:16 height:16 	
		on dll1 pressed do
			for i in getclassinstances coronamtl do
			( i.leveldiffuse = 1)

			spinner mes ""  pos:(grp1.pos+[33,54]) width:35 height:16 range:[1,100,renderers.current.system_materialEditorPreviewQuality] type:#float
button mesb "MEpq"  pos:(grp1.pos+[2,52]) width:30 height:20 tooltip:"Set Material Editor preview quality (1-low, 12-high)"		
on mesb pressed do (renderers.current.mtlEditor_quality = mes.value)
			
	checkbutton ShowHideMaps "ShowMaps" checked:false pos:(grp1.pos+[2,72]) width:66 height:20 tooltip:"Show/Hide maps in viewport"
		on ShowHideMaps changed state do
		( 	if state == on then (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse on) catch())
			else (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse off) catch()) 	)			
	
	button SceneMaterials2MaterialEditor "SM2ME" pos:(grp1.pos+[70,72]) width:44 height:20 enabled:true
		tooltip:"Clear material editor and move all scene materials to material editor"	
	on SceneMaterials2MaterialEditor pressed do
	(
	i=0
	while i< 24 do(
		i=i+1
		meditMaterials[i]=CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	
		--for i in getclassinstances coronamtl do
		--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )
	)

	i=0
	numberOfMaterials = sceneMaterials.count
	if numberOfMaterials > 24 then numberOfMaterials = 24

	while i< numberOfMaterials do(
		i=i+1
		meditMaterials[i]=sceneMaterials[i]
	)
)	
--.mtlEditor_quality (system_materialEditorPreviewQuality) : float


	button btnResetMtlEdit "cleanME" width:44 height:20 pos:(grp1.pos+[70,52])
		tooltip:"Clean material Editor with default white CoronaMaterials"		
	on btnResetMtlEdit pressed do
		try (
			(   for i = 1 to 24 do  
			(meditMaterials[i] = CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	)
			--for i in getclassinstances coronamtl do
			--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )					
			)
			) catch()
	
	button CConverter "Corona Converter" width:112 height:30 pos:(grp1.pos+[2,92])
		tooltip:"Convert scene to Corona materials/lights"	
	on CConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaConverter_v1.26.ms")	
				
	checkbox Displacecb "    Displacement" width:100 height:15 checked:true pos:(grp1.pos+[2,125])
		on Displacecb changed state do try (
		( 	renderDisplacements = state
		renderSceneDialog.update() 	)	) catch()
				
	checkbox Mtl_override "    Mtl.override" width:100 height:15 pos:(grp1.pos+[2,143])
		on Mtl_override changed state do try (
		( 	renderers.current.mtlOverride_enabled = state
		 	)	) catch()
			
	--------------------------------------------------------------------

button CPL "Corona Proxy Lister" width:112 height:18 tooltip:"" pos:(grp1.pos+[2,170])
		tooltip:"Display scene Cproxy list"	
	on CPL pressed do
			(fileIn "$scripts\CoronaRenderer\NS_CoronaProxyLister.ms")
	
button CLL "Corona Light Lister" width:112 height:18 tooltip:"" pos:(grp1.pos+[2,188])
		tooltip:"Display scene lights properties"	
	on CLL pressed do
			(filein "$scripts\CoronaRenderer\GTools_lightlister.ms")

	button CIes "Corona Ies Presets" width:112 height:18 pos:(grp1.pos+[2,206])
		tooltip:"Ies manager"	
	on CIes pressed do
			(filein "$scripts\CoronaRenderer\CoronaIesPresets v1.02.ms")				
			
			
	GroupBox grp2 "Render Settings: " pos:(grp1.pos+[0,230]) width:116 height:278
			
	local currenth = (renderers.current.progressive_timeLimit/3600000)
	local currentm = (renderers.current.progressive_timeLimit*60/3600000 - renderers.current.progressive_timeLimit/3600000*60)
			
	label TimeLimlbl "Time limit [hh:mm:ss]:" pos:(grp2.pos+[7,18])
	spinner TimeLimH "hrs" pos:(grp2.pos+[9,36]) width:48 range:[0,100,currenth] type:#integer tooltip:"hours"
	spinner TimeLimM "mins" pos:(grp2.pos+[69,36]) width:45 range:[0,59,currentm] type:#integer tooltip:"minutes" 
	--spinner TimeLimS "s" pos:(grp2.pos+[82,36]) width:32 range:[0,59,0] type:#integer tooltip:"seconds"
		on TimeLimH changed val do 	try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value)
			) catch()
		on TimeLimM changed val do try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value)
			) catch()
		--on TimeLimS changed val do 	try ( 
		--	(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value+1000*TimeLimS.value)
		--	) catch()
	
			
	spinner nls "Target_noise:"  pos:(grp2.pos+[21,56]) align:#right width:93 height:16 range:[0,25,renderers.current.adaptivity_targetError] type:#float
		tooltip:"Sets target noise level at which render stops. 6 for quick renders with denoise, 2 for clean renders."
	on nls changed val do try 
		(
			renderers.current.adaptivity_targetError = nls.value
			
		) catch()
	
	spinner passlim "Pass limit: " range:[0,10000,renderers.current.system_interactivePassLimit] width:80 type:#integer align:#right pos:(grp2.pos+[34,76])
		on passlim changed val do
			try ( (renderers.current.progressive_passLimit = passlim.value) ) catch()
				
	spinner giaa "GI/AA balance:" range:[1,64,renderers.current.performance_giAaBalance] width:82 type:#integer align:#right pos:(grp2.pos+[32,96])
		tooltip:"Priority for AA sampling = 2, Priority for GI sampling = 64"
		on giaa changed val do
			try ( (renderers.current.shading_giToAaRatio = giaa.value) ) catch()	
						
	button Renderrun "Render Scene F9" checked:false width:112 height:30 pos:(grp2.pos+[2,116])
		on Renderrun pressed do 
		(CoronaRenderer.CoronaFp.setDisplayedChannel 0	
		( max quick render ))
	
	button startIR "Start Interactive"  width:112 height:30 tooltip:"Start Interactive Render" pos:(grp2.pos+[2,146])
		on startIR pressed do try (
			 ( CoronaRenderer.CoronaFp.setDisplayedChannel 0
				 CoronaRenderer.CoronaFp.startInteractive() ) ) catch()
	
	checkbutton Renderview "RegionRnr On/Off" checked:false width:112 height:20 tooltip:"Region Render On(pressed)/Off(unpressed)" pos:(grp2.pos+[2,176])
		on Renderview changed state do
		( 	if state == on then 
					( setRenderType #region; EditRenderRegion.EditRegion() )
			else 	( EditRenderRegion.EditRegion() false; setRenderType #view )
		)
				 
	button rlrb "Resume Render" width:112 height:20 tooltip:"Resume Last Render" pos:(grp2.pos+[2,196])
		on rlrb pressed do
			( CoronaRenderer.CoronaFp.setDisplayedChannel 0
				coronarenderer.resumeRender() )		
	
	
	button rs "RenderSelection" width:112 height:20 tooltip:"Render Selected objects" enabled:true pos:(grp2.pos+[2,216])
		on rs pressed do
		(
		r=renderers.current.renderSelected_mode as integer
		renderers.current.renderSelected_mode=1
		CoronaRenderer.CoronaFp.setDisplayedChannel 0
		max quick render
		renderers.current.renderSelected_mode=r
		)
	
	button RSmask "RenderSelectionMask" width:112 height:20 tooltip:"Render quick mask from selection" pos:(grp2.pos+[2,236])
			on RSmask pressed do
			(filein "$scripts\CoronaRenderer\corona-quickMask.ms")	
		
	button btnAlbedo "Albedo test render" width:112 height:20 tooltip:"Test render for albedo errors in materials" pos:(grp2.pos+[2,256])
	on btnAlbedo pressed do
		(filein "$scripts\CoronaRenderer\corona-quickAlbedo2.ms")	
	
--------------------------------------------------------------------


	
		
	GroupBox grp4 "Framebuffer setup:" pos:(grp2.pos+[0,282]) width:116 height:170
	
	checkbutton ShowCrnVfb "Corona VFB sh/h " checked:false width:112 height:30 tooltip:"CoronaVFB show(pressed)/hide(unpressed)" pos:(grp4.pos+[2,16])
		on ShowCrnVfb changed state do
		(	if state == on then CoronaRenderer.CoronaFp.showVfb true
			else CoronaRenderer.CoronaFp.showVfb false 	)	
	
/*checkbox Enable_Denoiser "" width:15 height:15 --pos:(grp1.pos+[2,25])
		on Enable_Denoiser changed state do 
			(
		 	case of  
				(
				true: renderers.current.denoise_filterType = 2 
				false: renderers.current.denoise_filterType = 0
				)
			)
*/			
	spinner Denoiser "Denoising: "  width:78 height:16 range:[0.0,1.0,renderers.current.denoise_blendAmount] type:#float align:#right pos:(grp4.pos+[36,52])
		tooltip:"0.0 - no denoising at all, 0.6 - smart and artfacts free, 1.0 - JPEG-like clean image."
		on Denoiser changed val do try 
			(
			renderers.current.denoise_blendAmount = Denoiser.value
			if Denoiser.value == 0 then renderers.current.denoise_filterType = 0 else renderers.current.denoise_filterType = 2 label DYN "for v.1.4 upd. 02.06.16" pos:(OpenF10.pos+[-1,25])
			) catch()
			
	spinner Exposure "Exposure:"  width:76 height:16 range:[-20,20,renderers.current.colorMap_simpleExposure] type:#float align:#right pos:(grp4.pos+[38,72])
		tooltip:"Exposure (EV)"
		on Exposure changed val do try (
			(renderers.current.colorMap_simpleExposure = Exposure.value) ) catch() 
	
	spinner Contast "Contrast:"  width:72 height:16 range:[1,20,renderers.current.colorMap_contrast] type:#float align:#right pos:(grp4.pos+[42,92])
		on Contast changed val do try (
			(renderers.current.colorMap_contrast = Contast.value) 	) catch()
			
	spinner HLCompr "HighLight:"  width:74 height:16 range:[0.01,20,renderers.current.colorMap_highlightCompression] type:#float align:#right pos:(grp4.pos+[40,112])
		tooltip:"HighLight compress"
		on HLCompr changed val do try (
			(renderers.current.colorMap_highlightCompression = HLCompr.value)	) catch()

	spinner WBlnce "WhiteBl[K]:  "  width:104 height:16 type:#integer align:#right pos:(grp4.pos+[10,132])
		range:[1800,11000,renderers.current.colorMap_colorTemp] tooltip:"White balance [K]"
		on WBlnce changed val do try (
			(renderers.current.colorMap_colorTemp = WBlnce.value)	) catch()	
			
	spinner gamma "Gamma:" width:69 range:[-3.0,3.0,IDisplayGamma.gamma] type:#float align:#right pos:(grp4.pos+[45,152])
			on gamma changed val do try 
			(
				renderers.current.colormap_additionalGamma = gamma.value - 2.2
				IDisplayGamma.gamma = gamma.value
				FileInGamma = gamma.value
				FileOutGamma = gamma.value
			) catch()

	--------------------------------------------------------------------------
			
			
	GroupBox gCutilities "Utilities: " pos:(grp4.pos+[0,173]) width:116 height:37
		
		button Panarama_Exporter "Panarama Exporter" width:112 height:20 pos:(gCutilities.pos+[2,15])
		on Panarama_Exporter pressed do
		(filein "$scripts\CoronaRenderer\PanoramaExporter_v0.3.ms")
		
	GroupBox gCproxy "VRay > Corona tools" pos:(gCutilities.pos+[-0,40]) width:116 height:60
	
	button V2CPConverter "Vray > Corona Proxy" pos:(gCproxy.pos+[2,18]) width:112 height:20
		tooltip:"Vray to Corona Proxy Converter"	
	on V2CPConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaConvertProxies.ms")
	
	button V2CSConverter "Vray > Corona Scatter" pos:(gCproxy.pos+[2,38]) width:112 height:20
		tooltip:"Vray to Corona Scatter Converter"	
	on V2CSConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaScatterConverter_v0.03.ms")
	
	on Corona_tweaker open do
		(	
			try (
			displacecb.state = renderDisplacements;
		 	Mtl_override.state = renderers.current.mtlOverride_enabled;
			giaa.value =  renderers.current.shading_giToAaRatio;
			msi.value = renderers.current.shading_maxSampleIntensity;
			lightsmpls.value = renderers.current.lights_samplesMult;
			passlim.value = renderers.current.progressive_passLimit;
			tvfb.selection = renderers.current.vfb_type;
			imfilter.selection = renderers.current.image_filter_type;
			Exposure.value = renderers.current.colorMap_simpleExposure;
			Contast.value = renderers.current.colorMap_contrast;
			HLCompr.value = renderers.current.colorMap_highlightCompression;
			WBlnce.value = renderers.current.colorMap_colorTemp;
			gamma.value = 2.2+renderers.current.colormap_additionalGamma;
			numThreads.value = renderers.current.interactive_numThreads;
			passLimit.value = renderers.current.interactive_passLimit;
			TimeLimH.value = renderers.current.progressive_timeLimit/3600000;
			TimeLimM.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000)/60000; 
			TimeLimS.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000 - TimeLimM.value*60000)/1000
			BitmapProxyMgr.globalProxyEnable = false;
			IBitmapPager.enabled = false 
			)
			catch()
		)  
						
		on Corona_tweaker mousemove pos do --lbuttondown 
		(	
			try (
			displacecb.state = renderDisplacements;
		 	Mtl_override.state = renderers.current.mtlOverride_enabled;	
			giaa.value =  renderers.current.shading_giToAaRatio;
			msi.value = renderers.current.shading_maxSampleIntensity;
			lightsmpls.value = renderers.current.lights_samplesMult;
			passlim.value = renderers.current.progressive_passLimit;
			tvfb.selection = renderers.current.vfb_type;
			imfilter.selection = renderers.current.image_filter_type;
			Exposure.value = renderers.current.colorMap_simpleExposure;
			Contast.value = renderers.current.colorMap_contrast;
			HLCompr.value = renderers.current.colorMap_highlightCompression;
			WBlnce.value = renderers.current.colorMap_colorTemp;
			gamma.value = 2.2+renderers.current.colormap_additionalGamma;
			numThreads.value = renderers.current.interactive_numThreads;
			passLimit.value = renderers.current.interactive_passLimit;
			TimeLimH.value = renderers.current.progressive_timeLimit/3600000;
			TimeLimM.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000)/60000; 
			TimeLimS.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000 - TimeLimM.value*60000)/1000
			 )
			catch()	
		)
		
	button ascrb "Assign CoronaRn." width:112 height:20 pos:(gCutilities.pos+[2,108])
		tooltip:"set Assign Renderer to Corona with saved all settings of previous renderer"
		on ascrb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\PreviousRndrStngs.rps");
			renderers.production = CoronaRenderer() 
		)
		
	button rsb "Reset Corona" width:112 height:20 pos:(gCutilities.pos+[2,128])
		tooltip:"set Assign Renderer to Def.Scanlline and then return to Corona with saved all settings"
		on rsb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\coronareset.rps");
			renderers.production = Default_Scanline_Renderer();
			renderers.production = CoronaRenderer(); 
			renderpresets.LoadAll 0 (GetDir #renderPresets + "\\coronareset.rps")
		)
		
	button OpenF10 "Open F10" width:112 height:20 tooltip:"Open Render Setap dialog (F10)" pos:(gCutilities.pos+[2,148])
		on OpenF10 pressed do
		( if renderSceneDialog.isOpen()==true then renderSceneDialog.Close() 
			else renderSceneDialog.Open() 		)
			
	label lbl3 "for v.1.4 upd. 02.06.16" pos:(OpenF10.pos+[-1,25])
	label lbl2 "Created by  headoff," pos:(OpenF10.pos+[1,37]) 
	label lbl4 "archdizs@gmail.com" pos:(OpenF10.pos+[10,49]) 
	label lbl5 "updated by  vansan" pos:(OpenF10.pos+[5,61]) 
	label lbl6 "vansani4@yandex.ru" pos:(OpenF10.pos+[6,73]) 
	hyperlink coronawww "Corona-renderer.com" address:"https://corona-renderer.com/" visitedColor:(color 200 50 0) color:(color 200 50 0) align:#center pos:(OpenF10.pos+[5,90])
)
createdialog Corona_tweaker pos:[0,126] width:119 --menu:<RCMenu>
cui.RegisterDialogBar Corona_tweaker style:#(#cui_dock_left, #cui_dock_right, #cui_floatable, #cui_handles)
cui.DockDialogBar Corona_tweaker #cui_dock_left


--cui.FloatDialogBar Corona_tweaker
)